<?php 
error_reporting(5);
#########################################
# ChitChat version 2.7
# A PHP Messageboard/Guestbook Script
#
# by Jaime Kartak
# last update June 12, 2001
#
#  Copyright 2000, All Rights Reserved
# May be redistributed freely as long as this copyright
# notice is left intact
#
# based on Chit-Chat Script version 1.0 (written in Perl)
# by Mike Wheeler for Zack Zalon
#  Copyright 1996, All Rights Reserved
##########################################
# set user-defined options

$archive_period = "daily";
// set this to "daily", weekly or "monthly" to determine how frequently
// a new archive file is created.

$sendmail = 1;
// set this to 1 if you want every post emailed to the administrator, 0 if not.

$mailaddress = "admin@foo.com";
// email address of where posts are sent

$mailsubject = "Message Board entry";
// subject of email sent

$reverse = 1;
// allows reverse chronological listing of messages.  1 for reverse, 0 for not.

$show_icons = 1;
// allows users to choose icons to be posted with their message. 1 for allow, 0 for not.

$allow_URL = 1;
// allows users to post their website URL. 1 for allow, 0 for not.

$URL_to_blank = 1;
// opens user's website in new window. 1 for new window, 0 for same window.

$messagelen = 40;
// length long string lengths in a message should be broken at.


###########################################
# define time and date variables

$min = date("i");
$hour = date("G");
$mon = date("m");
$mday = date("d");
$mday_nice = date("j");
$year = date("y");
$month = date("n");
$wday = date("w");

#### how to do the admin functions
#
# The default password is "admin".
#
# To delete a post, type this in the message box:
# command::admin::#[::archive] replacing "admin" with your current password, # with
# the number of the post you want to delete, and optionally, you can also add the
# archive you want to delete from. The default is the current archive.
#
# To change the password, type this in the message box:
# command::admin::change password::new password  replacing "admin" with your
# current password, and "new password" with what you want your new password to be.
#
# To delete a series of posts, type this in the message box:
# command::admin::#-#  replacing "admin" with your current password and 
# replacing "#-#" with the series of posts you want removed
# i.e. putting in 4-6 removes posts #4, #5 and #6.
#
# To delete an entire archive, type this in the message box:
# command::admin::delete  replacing "admin" with your current password.
#
# You can block full ip addresses easily.
# To add an ip address to the "blocked ip addresses" list, type this in the message box:
# command::admin::add ip::ip  replacing "admin" with your current password and 
# replacing "ip" with the ip address you want to add to your blocked ips list
#
# To remove an ip address from the "blocked ip addresses" list, type this in the message box:
# command::admin::remove ip::ip  replacing "admin" with your current password and 
# replacing "ip" with the ip address you want to remove from your blocked ips list
#
# To simply list what is on your "blocked ip addresses" list, type this in the message box:
# command::admin::list ips  replacing "admin" with your current password
#
# If you want to block a partial ip address, you will need to add that to the code MANUALLY.
# (see the code below to find out where and how).
#
# There are a number of default "bad words" that will be censored automatically.
# To add a word to the "bad words" list, type this in the message box:
# command::admin::add word::word  replacing "admin" with your current password and 
# replacing "word" with the word you want to add to your bad words list
#
# To remove a word from the "bad words" list, type this in the message box:
# command::admin::remove word::word  replacing "admin" with your current password and 
# replacing "word" with the word you want to remove from your bad words list
#
# To simply list what is on your "bad words" list, type this in the message box:
# command::admin::list words  replacing "admin" with your current password
#
# That's it!
#
##########################################

if (!ereg(".*\@.*\..*",$mail)) {
   $mail = "";
}

// keep basic HTML from displaying in messages to avoid people putting their own graphics, etc. on the board
if ($message != ""){
   $message = ereg_replace("<","&lt;",$message);
   $message = ereg_replace(">","&gt;",$message);
   $message = ereg_replace("\r","<br>",$message);
   $message = ereg_replace("\n","",$message);
   
   // fix it so it will print quotes and other escape characters without slashes if magic quotes enabled!
   if(get_magic_quotes_gpc()) {
      $message=stripslashes($message);
   }
}

if ($hour < "12") {
   $ampm = "am";
}

if ($hour > "11") {
   $ampm = "pm";
}

if ($hour > "12") {
   $hour = $hour-12;
}

if ($hour == "0") {
   $hour = 12;
}

$days = array('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
$months = array('blank','Jan','Feb','Mar','Apr','May','June','July','Aug','Sept','Oct','Nov','Dec');
$fullmonths = array('blank','January','February','March','April','May','June','July','August','September','October','November','December');

$time_o_day = "$hour:$min$ampm";
$archive_file = "$year$mon$mday";
$month = $fullmonths[$month];
$fullyear = $year+2000;
$date = $month." $mday_nice, $fullyear";

// daily archive board
if ($archive_period == "daily") {
   $archive_file = "$year$mon$mday";
}

// weekly archive board
if ($archive_period == "weekly") {
   $wkbeg = $wday * 86400;
   $wkend = (6 - $wday) * 86400;
     
   $bmon = date("n",time() - $wkbeg);
   $bmday = date("j",time() - $wkbeg);
   $emon = date("n",time() + $wkend);
   $emday = date("j",time() + $wkend);
   $byear = date("y",time() - $wkbeg);
   $eyear = date("y",time() + $wkend);

   if ($bmon < 10) {
      $bmon = "0$bmon";
   }

   if ($bmday < 10) {
      $bmday = "0$bmday";
   }

   if ($emday < 10) {
      $emday = "0$emday";
   }

   if ($byear > 99){
      $byear = $byear-100;
   }
   
   $archive_file = "$byear$bmon$bmday-$emday";   
} 

// monthly archive board

if ($archive_period == "monthly") {
   $archive_file = "$year$mon";
}

##########################################
# admin 

if (ereg("command::",$message)) {   
   ereg_replace("/\n","",$message);
   list($bogus,$apassword,$admin_command,$admin_option) = split("::",$message);  
   $adpassword = crypt($apassword,MW);

   $filename = "files/passwd.txt";
   if (file_exists($filename)) {
      $fd = fopen("files/passwd.txt","r");
      $passtest = fread($fd, filesize($filename));
      fclose($fd);
   }
   else{
      $passtest = "MW5i2wkjf/p3k";
   }
   ereg_replace("/\n","",$passtest);
   if(! $admin_option){
      $admin_option = "$archive_file";
   }
   
   if($passtest == "$adpassword") {
      if($admin_command == "change password") {
         $newpass = crypt($admin_option,MW);
         $file = fopen("files/passwd.txt","w");         
         fputs($file,$newpass);
         fclose($file);
         pagetop();
         echo "<br><table width=95% align=\"center\"><tr><td><font face=\"arial\">The password has been changed to <b>$admin_option</b><p>\n";
         echo "DO NOT forget the new password.</font>\n";
         echo "<form method=\"post\" action=\"chitchat.php\">\n";
         echo "<input type=\"submit\" value=\"Reload Board\">\n";
         echo "</form>\n";
         echo "</td></tr></table>\n";
         footer();
         exit;
      }
      elseif($admin_command == "delete") {
         unlink("files/archive/$admin_option\.txt");
         $file = fopen("files/data.txt","w");
         fclose($file);
         include("chitchat_mainpage.php");
      }
      elseif($admin_command == "add ip") {
         $ipfile = file("files/ip.txt");
         $admin_option = "$admin_option\n";
         array_push($ipfile,$admin_option);
         pagetop();
         echo "<br><table width=95% align=\"center\"><tr><td><font face=\"arial\">The ip address <b>$admin_option</b> was added to your blocked ip addresses list.<p>";
         echo "Your current list is:<p>";
            foreach($ipfile as $ipaddr){
               echo "$ipaddr<br>";
            }
         $file = fopen("files/ip.txt","w");
            foreach($ipfile as $ipaddr){
               fputs($file,$ipaddr);
            }
         fclose($file);
         echo "<form method=\"post\" action=\"chitchat.php\">\n";
         echo "<input type=\"submit\" value=\"Reload Board\">\n";
         echo "</form>\n";
         echo "</font></td></tr></table>\n";
         footer();
         exit;
      }
      elseif($admin_command == "remove ip") {
         $ipfile = file("files/ip.txt");
         $editedfile = array();
         foreach($ipfile as $ipaddr){
            $ipaddr = ereg_replace("\n","",$ipaddr);
            if($admin_option != $ipaddr){
               $ipaddr = "$ipaddr\n";
               array_push($editedfile,$ipaddr);
            }
         }
         pagetop();
         echo "<br><table width=95% align=\"center\"><tr><td><font face=\"arial\">The ip address <b>$admin_option</b> was removed from your blocked ip addresses list.<p>";
         echo "Your current list is:<p>";
            foreach($editedfile as $ipaddr){
               echo "$ipaddr<br>";
            }
         $file = fopen("files/ip.txt","w");
            foreach($editedfile as $ipaddr){
               fputs($file,$ipaddr);
            }
         fclose($file);
         echo "<form method=\"post\" action=\"chitchat.php\">\n";
         echo "<input type=\"submit\" value=\"Reload Board\">\n";
         echo "</form>\n";
         echo "</font></td></tr></table>\n";
         footer();
         exit;
      }
      elseif(ereg("list ips",$admin_command)) {
         $ipfile = file("files/ip.txt");
         pagetop();
         echo "<br><table width=95% align=\"center\"><tr><td><font face=\"arial\">";
         echo "Your current blocked ip addresses list is:<p>";
            foreach($ipfile as $ipaddr){
               echo "$ipaddr<br>";
            }
         echo "<form method=\"post\" action=\"chitchat.php\">\n";
         echo "<input type=\"submit\" value=\"Reload Board\">\n";
         echo "</form>\n";
         echo "</font></td></tr></table>\n";
         footer();
         exit;
      }
      elseif($admin_command == "add word") {
         $badwordfile = file("files/strip.txt");
         $admin_option = "$admin_option\n";
         array_push($badwordfile,$admin_option);
         pagetop();
         echo "<br><table width=95% align=\"center\"><tr><td><font face=\"arial\">The word <b>$admin_option</b> was added to your \"bad words\" list.<p>";
         echo "Your current list is:<p>";
            foreach($badwordfile as $badword){
               echo "$badword<br>";
            }
         $file = fopen("files/strip.txt","w");
            foreach($badwordfile as $badword){
               fputs($file,$badword);
            }
         fclose($file);
         echo "<form method=\"post\" action=\"chitchat.php\">\n";
         echo "<input type=\"submit\" value=\"Reload Board\">\n";
         echo "</form>\n";
         echo "</font></td></tr></table>\n";
         footer();
         exit;
      }
      elseif($admin_command == "remove word") {
         $badwordfile = file("files/strip.txt");
         $editedfile = array();
         foreach($badwordfile as $badword){
            $badword = ereg_replace("\n","",$badword);
            if($admin_option != $badword){
               $badword = "$badword\n";
               array_push($editedfile,$badword);
            }
         }
         pagetop();
         echo "<br><table width=95% align=\"center\"><tr><td><font face=\"arial\">The word <b>$admin_option</b> was removed from your \"bad words\" list.<p>";
         echo "Your current list is:<p>";
            foreach($editedfile as $badword){
               echo "$badword<br>";
            }
         $file = fopen("files/strip.txt","w");
            foreach($editedfile as $badword){
               fputs($file,$badword);
            }
         fclose($file);
         echo "<form method=\"post\" action=\"chitchat.php\">\n";
         echo "<input type=\"submit\" value=\"Reload Board\">\n";
         echo "</form>\n";
         echo "</font></td></tr></table>\n";
         footer();
         exit;
      }
      elseif(ereg("list words",$admin_command)) {
         $badwordfile = file("files/strip.txt");
         pagetop();
         echo "<br><table width=95% align=\"center\"><tr><td><font face=\"arial\">";
         echo "Your current \"bad words\" list is:<p>";
            foreach($badwordfile as $badword){
               echo "$badword<br>";
            }
         echo "<form method=\"post\" action=\"chitchat.php\">\n";
         echo "<input type=\"submit\" value=\"Reload Board\">\n";
         echo "</form>\n";
         echo "</font></td></tr></table>\n";
         footer();
         exit;
      }
      elseif (ereg("^command::$apassword::[0-9]", $message)){
         $file = file("files/archive/$admin_option.txt");
         if(ereg("-",$admin_command)) {
            list($low,$high) = split("-",$admin_command); 
            $newfile = array();
            foreach($file as $line){
               list($bogus,$postnumber,$bogusb) = split("--",$line);
               if ($postnumber < $low || $postnumber > $high) {
                  array_push($newfile,$line);
               }
            }
         }
         else {
            $newfile = array();
            foreach($file as $line){
               list($bogus,$postnumber,$bogusb) = split("--",$line);
               if ($postnumber != $admin_command) {
                  array_push($newfile,$line);
               }
            }
         }
         $file = fopen("files/archive/$admin_option.txt","w");
         foreach($newfile as $newline){
            fputs($file,$newline);
         }
         fclose($file);
         $archive_file = "$admin_option";
         include("chitchat_mainpage.php");
         exit;
      } else {
         $archive_file = $archive_date;
         include("chitchat_mainpage.php");
         exit;
      }
     
   }
   else{
      pagetop();
      echo "<br><br><table width=95% align=\"center\"><tr><td><font face=\"arial\">The password you entered was incorrect and nothing will be done.<p>";
      echo "<form method=\"post\" action=\"chitchat.php\">\n";
      echo "<input type=\"submit\" value=\"Reload Board\">\n";
      echo "</form>\n";
      echo "</td></tr></table></font>\n";
      footer();
      exit;
   }
}

##########################################
# block IP address

if (getenv("HTTP_X_FORWARDED_FOR")){ 
   $ip=getenv("HTTP_X_FORWARDED_FOR"); 
} else { 
   $ip=getenv("REMOTE_ADDR"); 
} 

// read in list of blocked ips, if the user's ip is on the list, they are blocked!

$blockedipfile = file("files/ip.txt");
foreach($blockedipfile as $ipaddr){
   $ipaddr = ereg_replace("\n","",$ipaddr);
   if($ip == $ipaddr){
      blocked();
   }
} 

// list of partial ips to block if you have to block by subnet
// MUST BE ADDED MANUALLY TO THE CODE IF YOU USE THIS! 

// example of blocking first two portions of ip
// if (ereg("^144\.74\.",$ip)) { 
//    blocked();
// }
//
// example of blocking first three portions of ip
// if (ereg("^204\.167\.146\.",$ip)) { 
//    blocked();
// }
  

##########################################
# form actions

if ($form_action == "Post"){

   //check to make sure they've filled in the form
   if(! $name || ! $message){
      pagetop();
      echo "<center><table width=95%><tr><td>\n";
      echo "<p><p><font face=\"Comic Sans MS,Arial,Helvetica\">Oops! You need to fill out at least the name and message fields to be able to post a message.</font><p>\n";
      echo "<font face=\"Comic Sans MS,Arial,Helvetica\">If you want to post, go back and fill in these fields and try again.</face></td></tr></table></center><p>\n";
      footer();
      exit;
   }
   
   $data_array = array();
   $data_file = file("files/data.txt");

   for ($i=0; $i<count($data_file); $i++) {
      array_push($data_array,$data_file[$i]);
   }

   foreach ($data_array as $file){
      list($count,$file_date) = split("::",$file);
   }
   
   if ($archive_file != "$file_date") {
      $count = 0;
   }
   
   $count++;
   
   // fix it so message string will not be too long ...
   
   $message = ereg_replace("<br>","<br> ",$message);
   $messagewords = explode(" ",$message);
   $message = "";
   $lastword = "";
   foreach ($messagewords as $words){
      if(!ereg("<br>$",$lastword)) {
         $allwords = "<br>";
      } else {
         $allwords = "";
      }
     
      if(strlen($words) > $messagelen){
         if(strlen($words) < ($messagelen*2+1)){
            $allwords .= substr($words,0,$messagelen)."<br>".substr($words,$messagelen,$messagelen);
         } elseif (strlen($words) > ($messagelen*2) && strlen($words) < ($messagelen*3+1)){ 
            $allwords .= substr($words,0,$messagelen)."<br>".substr($words,$messagelen,$messagelen)."<br>".substr($words,$messagelen*2,$messagelen);
         } elseif (strlen($words) > ($messagelen*3) && strlen($words) < ($messagelen*4+1)){ 
            $allwords .= substr($words,0,$messagelen)."<br>".substr($words,$messagelen,$messagelen)."<br>".substr($words,$messagelen*2,$messagelen)."<br>".substr($words,$messagelen*3,$messagelen);
         } elseif (strlen($words) > ($messagelen*4) && strlen($words) < ($messagelen*5+1)){ 
            $allwords .= substr($words,0,$messagelen)."<br>".substr($words,$messagelen,$messagelen)."<br>".substr($words,$messagelen*2,$messagelen)."<br>".substr($words,$messagelen*3,$messagelen)."<br>".substr($words,$messagelen*4,$messagelen);
         } elseif (strlen($words) > ($messagelen*5) && strlen($words) < ($messagelen*6+1)){ 
            $allwords .= substr($words,0,$messagelen)."<br>".substr($words,$messagelen,$messagelen)."<br>".substr($words,$messagelen*2,$messagelen)."<br>".substr($words,$messagelen*3,$messagelen)."<br>".substr($words,$messagelen*4,$messagelen)."<br>".substr($words,$messagelen*5,$messagelen);
         } else { 
            $allwords .= substr($words,0,$messagelen)."<br>".substr($words,$messagelen,$messagelen)."<br>".substr($words,$messagelen*2,$messagelen)."<br>".substr($words,$messagelen*3,$messagelen)."<br>".substr($words,$messagelen*4,$messagelen)."<br>".substr($words,$messagelen*5,$messagelen)."<br>".substr($words,$messagelen*6,$messagelen);
         }
         //echo strlen($words)."<br>";
         $message .= $allwords." ";
         //echo "$allwords<br>";
      } else{
         $message .= $words." ";
      }
      $lastword = $words;
   }

   //set up what is to be included in the post to be saved
   if($mail && !$allow_URL){
      $fullmessage = "<font color=red><!--$count--><small>$count. </small></font>";
      if ($show_icons == 1){
         if ($icons != "none"){
            $fullmessage .= "<img src=\"images/$icons\"> ";
         }
      }
      $fullmessage .= "<a href=\"mailto:$mail\"><small>$name</small></a>&nbsp;&nbsp;<small>$time_o_day $date</small><br><br><small>|$message|</small></b></i><hr>\n";
   }
   elseif($mail && $allow_URL & $website != "http://"){
      $fullmessage = "<font color=red><!--$count--><small>$count. </small></font>";
      if ($show_icons == 1){
         if ($icons != "none"){
            $fullmessage .= "<img src=\"images/$icons\"> ";
         }
      }
      if($URL_to_blank == 1){
         $fullmessage .= "<a href=\"mailto:$mail\"><small>$name</small></a>&nbsp;&nbsp;<small>$time_o_day $date</small><br><small>website: <a href=\"$website\" target=\"_blank\">$website</a></small><br><br><small>|$message|</small></b></i><hr>\n";
      } else {
         $fullmessage .= "<a href=\"mailto:$mail\"><small>$name</small></a>&nbsp;&nbsp;<small>$time_o_day $date</small><br><small>website: <a href=\"$website\">$website</a></small><br><br><small>|$message|</small></b></i><hr>\n";
      }
   }
   elseif($mail && $allow_URL & $website == "http://"){
      $fullmessage = "<font color=red><!--$count--><small>$count. </small></font>";
      if ($show_icons == 1){
         if ($icons != "none"){
            $fullmessage .= "<img src=\"images/$icons\"> ";
         }
      }
      $fullmessage .= "<a href=\"mailto:$mail\"><small>$name</small></a>&nbsp;&nbsp;<small>$time_o_day $date</small><br><br><small>|$message|</small></b></i><hr>\n";
   }
   elseif(!$mail && $allow_URL && $website != "http://"){
      $fullmessage = "<font color=red><!--$count--><small>$count. </small></font>";
      if ($show_icons == 1){
         if ($icons != "none"){
            $fullmessage .= "<img src=\"images/$icons\"> ";
         }
      }
      if($URL_to_blank == 1){
         $fullmessage .= "<small>$name</small>&nbsp;&nbsp;<small>$time_o_day $date</small><br><small>website: <a href=\"$website\" target=\"_blank\">$website</a></small><br><br><small>|$message|</small></b></i><hr>\n";
      } else {
         $fullmessage .= "<small>$name</small>&nbsp;&nbsp;<small>$time_o_day $date</small><br><small>website: <a href=\"$website\">$website</a></small><br><br><small>|$message|</small></b></i><hr>\n";
      }
   }
   elseif(!$mail && $allow_URL && $website == "http://"){
      $fullmessage = "<font color=red><!--$count--><small>$count. </small></font>";
      if ($show_icons == 1){
         if ($icons != "none"){
            $fullmessage .= "<img src=\"images/$icons\"> ";
         }
      }
      $fullmessage .= "<small>$name</small>&nbsp;&nbsp;<small>$time_o_day $date</small><br><br><small>|$message|</small></b></i><hr>\n";
   }
   else {
      $fullmessage = "<font color=red><!--$count--><small>$count. </small></font>";
      if ($show_icons == 1){
         if ($icons != "none"){
            $fullmessage .= "<img src=\"images/$icons\"> ";
         }
      }
      $fullmessage .= "<small>$name</small>&nbsp;&nbsp;<small>$time_o_day $date</small><br><br><small>|$message|</small></i><hr>\n";
   }
         
   //check for double-posting ... if last message and current message don't match, post it
   $posts = file("files/archive/$archive_file.txt","r");
   $posts = array_reverse($posts);
   $prevmessage = $posts[0];
   list($mess1,$lastmessage,$mess2) = split("\|",$prevmessage);

   if ($lastmessage != $message) {
      $file = fopen("files/archive/$archive_file.txt","a");
      fputs($file,$fullmessage);
      fclose($file);
      $file = fopen("files/data.txt","w"); 
      fputs($file,"$count::$archive_file");
      fclose($file);
   
      // send post as email
      if ($sendmail == 1){
         $message = ereg_replace("<br>","\n",$message);
         $message = ereg_replace("&gt;",">",$message);
         $message = ereg_replace("&lt;","<",$message);
         $Host = getenv("REMOTE_HOST");
         $Addr = getenv("REMOTE_ADDR");
         $With = getenv("HTTP_USER_AGENT");
   
mail($mailaddress,$mailsubject,"
on $date at $time_o_day, $name wrote in message #$count:
=======================================================
$message
=======================================================
   
Host: $Host
Addr: $ip
With: $With
","From:\"$name\"<$mail>");
      }
   }
   include("chitchat_mainpage.php");
}
elseif ($form_action == "Archive"){
   $archive_file = $archive_date;
   include("chitchat_mainpage.php");
}
elseif ($form_action == "Reload Page") {
   include("chitchat_mainpage.php");
}
else {
   include("chitchat_mainpage.php");
}
exit;

##########################################
# FUNCTIONS
##########################################

##########################################
# blocked IP address error page

function blocked() {
   echo "<center><font face=\"Comic Sans MS,Arial,Helvetica\">Sorry ... your access has been blocked at this time....</font></center><p>\n";
   exit;
}

##########################################
# header and footer

function pagetop() {
   $file = fopen("files/header.html","r");
   fpassthru($file);
}


function footer() {
   $file = fopen("files/footer.html","r");
   fpassthru($file);
}

?>